Const Blitz2D=True
;If Blitz2D=False, the buffer won't be locked, and the game will draw less lines..
;Blitz2D allows "Lines whilst LockBuffer'd", BlitzPlus doesn't, and Blitz3D appears to depend on the version you're using.

;Try it True, first, if you get a blank page, change it to False..

Global CPUTick ; CPUTick is used to count frames, add one each frame and the game ticks away.
				;For the most part, in this game, it's used to limit the "Jitteryness" of lines.


;Paperback - Hunchback meets Paper drawings..				

;Room for Improvement
;. Many types of Baddies
;. New Levels
;. Levels in Files, rather than code..
;. Level Editor				
;. Improve "Balls" physics
;. How about a nice Page turning effect, between levels?
;. Could probably do with some FrameLimiting.. I can never be bothered with that stuff!
;. And much much more..

Page=1 ; = Start Level!


;Quick Navigation
	;Levels are currently stored at the Label "LoadPage"
	;Player Tech and Baddie Tech are also labelled, and the MainLoop is roughly at StartGame
	;Most of the functions, you'll probably want to leave as they are, but the Stickman one has an unused parameter, HATS, which you can use to add silly costumes, or whatever, to the stickmen..
	;And, of course, the Page and Blitz2D variables are right up here at the top, where you can easily access them.


Graphics 800,600,32,2
SetBuffer BackBuffer()
Floors=CreateImage(800,600)
IFloor=ImageBuffer(Floors)		;We'll use this to check for collisions of Stickman vs Floor.
FloorCopy=CreateImage(800,600)	;Well, technically, we use this, but only 'cos of an odd Slow-down in blitz
								;If you draw onto an image that you're "imagescollide"'ing, the collision detection becomes slow..
								;So, instead we draw onto one buffer, then CopyRect that image onto the collision buffer.
								;Not so sure why, but Blitz doesn't seem to mind us doing that, so.. If it works, use it!
SeedRnd MilliSecs()

Largefont=LoadFont("Comic Sans MS",64)
SmallFont=LoadFont("Comic Sans MS",16)
SetFont Smallfont

Dim ColChk(10)


ColChk(1)=CreateImage(30,80)	;Collision Check for stickmen
SetBuffer ImageBuffer(colchk(1))
	col(2)
	stickman 15,80


ColChk(2)=CreateImage(30,80)	;Collision Check for Stickman's Width, without hit legs..  ie check for walls.
SetBuffer ImageBuffer(colchk(2))
	col(2)
	Rect 4,4,22,70,1

ColChk(3)=CreateImage(32,32)	;Collision Check for Ball
SetBuffer ImageBuffer(colchk(3))
	col(2)
	Oval 0,0,32,32,1

SetBuffer BackBuffer()

Const Win=1
Const Death=2


; We keep the room (/Page!) in the room array, but then copy it all into the Show array, and show that one..
Dim Room(1000,2)
Dim Show(1000,2)


Global PlrX,PlrY


Type die ;die as in Bad.die
Field X1	;Most baddies move from X1,Y1 to X2,Y2, then back again.
Field Y1
Field X2	;Otherwise X2 and Y2 will be used as Temp values..
Field Y2
Field Style	;Which baddie type it is..
Field Frames;How many frames in the baddies Circuit
Field Frame	;Which frame they're on.
Field FrameDirection	;Frame+ Direction, as in if at the end, instead of looping, do a Ping-Pong instead.
End Type

Type xt	;For Text on the page
Field x
Field y
Field txt$
Field cl	;Color
End Type 





Paper=LoadImage("system/035/paper.png")



Gosub LoadPage



.StartGame
WLX=0  ;Walk to X position
JumpTick=0 ;Reset Jump
EndofGame=0

Repeat
	DrawImage paper,0,0

	For te.xt=Each xt
		col(te\cl)
		Text te\x,te\y,te\txt$
	Next

	
	If Blitz2D=True Then LockBuffer BackBuffer()
	
	ShowRoom
	CPUTick=CPUTick+1
		
	LDrawn=0 	;Lets us keep count of the lines drawn per frame.
	Gosub PlayerTech
	Gosub BaddieTech	
	
	If Blitz2D=True Then UnlockBuffer BackBuffer()

	If MouseDown(1)=0 And MouseDown(2)=0 Then mudown=0

		;This is the IMAGE BASED version of the game.  Essentially created to check collisions with walls and stuff..
		;Cls
		;DrawImage floors,0,0
		;DrawImage colchk(1),plrx,plry-80

	If PlrX>775 Then endofgame=Win

	Flip
	If KeyDown(1) Then endofgame=99
Until endofgame<>0

If EndofGame=Win Then Page=Page+1
If EndofGame=99 Then End

DrawImage paper,0,0
Flip
Gosub LoadPage
Goto StartGame








.PlayerTech
	col(2)
	Stickman PlrX,PlrY,WLX<>0
	
	If MouseDown(2) And mudown=0 Then WLX=MouseX():WLY=MouseY():mudown=1

;Left+Right Wall Checks	
	CanGoLeft=1
	If ImagesCollide(Floorcopy,0,0,0,ColChk(2),PlrX-17,PlrY-80,0)=1 Then CanGoLeft=0
	CanGoRight=1
	If ImagesCollide(Floorcopy,0,0,0,ColChk(2),PlrX-13,PlrY-80,0)=1 Then CanGoRight=0

If jumptick>88 Then onfloor=0

;Floor Check
	If JumpTick=0
	did=0
	fall=0
	rise=0
	OnFloor=1
	For y=1 To 8
		If ImagesCollide(Floorcopy,0,0,0,ColChk(1),PlrX-15,PlrY-(80)+y,0)=0
			fall=y:OnFloor=0
		EndIf
		If ImagesCollide(Floorcopy,0,0,0,ColChk(1),PlrX-15,PlrY-80,0)=1 And did=0
			If ImagesCollide(Floorcopy,0,0,0,ColChk(1),PlrX-15,PlrY-(80+y),0)=0
			If rise=0 Then rise=y
			EndIf
		EndIf
	Next
	
	If fall>0 Then plry=plry+fall:cangoleft=0:cangoright=0
	If rise>0 Then plry=plry-rise
	
		
	EndIf


;If Walk marker is set, Walk to it.	
	If WLX<>0
		drawline(WLX+(Sin(CPUTick*4)*8),WLY+(Cos(CPUTick*4)*8),WLX-(Sin(CPUTick*4)*8),WLY-(Cos(CPUTick*4)*8)) : drawline(WLX+(Sin(CPUTick*4+90)*8),WLY+(Cos(CPUTick*4+90)*8),WLX-(Sin(CPUTick*4+90)*8),WLY-(Cos(CPUTick*4+90)*8))
		If WLX>PlrX And CanGoRight=1 Then PlrX=PlrX+2
		If WLX<PlrX And CanGoLeft=1 Then PlrX=PlrX-2
		If Abs(WLX-PlrX)<2 Then WLX=0
	EndIf
	

;Jump Line Drawing/Power Setting
	If MouseDown(1) And OnFloor=1
		WLX=0
		JumpStartX=PlrX
		JumpStartY=PlrY
		JumpPower#=MouseX()-JumpStartX
		If JumpPower<-100 Then JumpPower=-100
		If JumpPower>100 Then JumpPower=100
		wx#=JumpStartX
		wy#=JumpStartY-50
		ashow=1
		For n=90 To 270 Step 10
		ashow=1-ashow
			col(1)
			jY#=wy#-Sin(n)*(Abs(JumpPower#/3))
			jx#=wx#+JumpPower#/18
			If ashow=1 Then Line wx,wy,jx,jy
			wx=jx:wy=jy
		Next

		mudown=1
		JumpTick=88
	EndIf

;Actual Jumping	
	If (MouseDown(1)=0 Or mudown=0) And jumptick>0
		JumpTick=JumpTick+4
		If CanGoRight=1 Then plrx=plrx+(JumpPower/45)
		plry=plry-(Sin(JumpTick)*(Abs(JumpPower#/6)))
		If JumpTick=>270 Then JumpTick=0
		If ImagesCollide(Floorcopy,0,0,0,ColChk(1),PlrX-15,PlrY-60,0) And jumptick>180 Then jumptick=0
	EndIf
	
	
	
Return


.BaddieTech

	For bad.die=Each die
	Kill=0
	
		Select bad\style
			Case 1		;Type 1 = Red Guy, moves from X1,y1 to x2,y2, and back again..
				col(3)
				bad\frame=bad\frame+bad\frameDirection
				If bad\frame>bad\frames Then bad\framedirection=-1
				If bad\frame<1 Then bad\framedirection=1
				
				AtX=((bad\frame*((bad\x2)-(bad\x1)))/bad\Frames)+bad\x1
				AtY=((bad\frame*((bad\y2)-(bad\y1)))/bad\Frames)+bad\y1
				Stickman AtX,AtY,1
				If ImagesCollide(colchk(1),AtX-15,AtY-80,0,colchk(1),PlrX-15,PlrY-80,0)
				EndofGame=Death
				EndIf
				
			Case 2		;Type 2 = Invisible Ball Thrower..  ie the thrower is invisible.. The balls are visisble..  That'd be daft the other way round..
				bad\frame=bad\frame+1
				If bad\frame>bad\frames 
					bad\frame=0
						bad2.die=New die
						bad2\x1=bad\x1
						bad2\y1=bad\y1
						bad2\x2=bad\x2
						bad2\y2=bad\y2
						bad2\style=99						
				EndIf
				
			Case 99		;Type 99 = Visible Balls from the Invisible Thrower.. 
						;Technically should be barrels, but balls are easier to do..
						;Why not try making them into barrels!
						;Note : Although Balls do follow the contours of the ground, they do not bounce off walls, or even bother with physics..  They just keep on rollin'!
				bad\x1=bad\x1+bad\x2
				fall=0
				rise=0
					For y=1 To 8
						If ImagesCollide(Floorcopy,0,0,0,ColChk(3),Bad\x1-15,Bad\y1-(32)+y,0)=0
							fall=y
						EndIf
						If ImagesCollide(Floorcopy,0,0,0,ColChk(3),Bad\x1-15,Bad\y1-(32),0)=1 And did=0
							If ImagesCollide(Floorcopy,0,0,0,ColChk(3),Bad\x1-15,Bad\y1-(32+y),0)=0
								If rise=0 Then rise=y
							EndIf
						EndIf
					Next				
				If fall>0 Then bad\y1=bad\y1+fall
				If rise>0 Then bad\y1=bad\y1-rise
				col(3)
				For n=0 To 360 Step 36
				drawline(bad\x1+(Sin(n)*15) , (bad\y1-15)-Cos(n)*15 , bad\x1+(Sin(n+36)*15) , (bad\y1-15)-Cos(n+36)*15  )
				Next
				
				If ImagesCollide(ColChk(3),Bad\x1-15,Bad\y1-(32),0,colchk(1),PlrX-15,PlrY-80,0) Then EndOfGame=Death
				
				If bad\x1<-30 Or bad\x1>830 Then kill=1
				
		End Select
		
		If Kill=1 Then Delete bad.die
	Next
Return



;This is where you define the levels..  No saved levels, just lots of lines of code.  Whoop!
.LoadPage
For te.xt=Each xt
Delete te.xt
Next
For bad.die=Each die
	Delete bad.die
Next
room(0,0)=1
show(0,0)=-1
For n=1 To 1000
room(n,0)=0
room(n,1)=0
room(n,2)=0
show(n,0)=0
show(n,1)=0
show(n,2)=0
Next

SetBuffer IFloor
Cls

Select Page
	Case 1
		AddLine(0,300,100,310,4)
		AddLine(100,310,96,500,4)
		AddLine(96,500,160,490,4)
		AddBaddy(130,100,130,490,1,100)	;Baddy Type 1 = Red Stickman.
										;X,Y, = Start Location. X2,Y2 = End Location.  Stickman then moves "Ping Pong" between these two points.
										;1 = His type..
										;100 = The loop lasts 100 frames.  I think..  Unless I messed up the counting code.   It's something like that, anyway!
										
		AddLine(160,490,163,304,4)
		AddLine(163,304,240,300,4)
		AddLine(240,300,242,500,4)
		AddLine(242,500,302,510,4)
		AddBaddy(272,100,272,490,1,80)

		AddLine(302,510,304,300,4)
		AddLine(304,300,360,290,4)
		AddLine(360,290,357,502,4)
		AddLine(357,502,440,508,4)
		
		AddBaddy(400,100,390,490,1,60)
		
		AddLine(440,508,442,303,4)
		AddLine(442,303,500,300,4)
		AddLine(500,300,502,422,4)
		AddLine(502,422,560,428,4)
		
		AddBaddy(530,100,530,390,1,60)		
		
		AddLine(560,428,562,287,4)
		AddLine(562,287,600,297,4)
		AddLine(600,297,602,424,4)
		AddLine(602,424,680,419,4)

		AddBaddy(640,100,640,390,1,40)		

		AddLine(680,419,687,340,4)
		AddLine(687,340,720,320,4)
		AddLine(720,320,780,324,4)
		AddLine(780,324,810,324,4)
		
		AddText(4,2,"LMB=Jump",4)	;AddText's Y position = Which line on the paper..
		AddText(4,3,"RMB=Walk",4)	;X,Y,Txt$,Col
		
	Case 2
		AddLine(0,300,100,304,4)
		AddLine(100,304,200,302,4)
		AddLine(200,302,300,298,4)
		AddLine(300,298,400,304,4)
		AddLine(400,304,500,300,4)
		AddLine(500,300,600,298,4)
		AddLine(600,298,700,300,4)
		AddLine(700,300,800,310,4)
		AddLine(700,200,800,190,4)
		
		AddBaddy(800,180,-1,170,2,180);Baddy Type 2 = Ball Thrower
									;Set the location where balls come from.
									;2nd X Location defines which way the balls go, and how fast..
									;2nd Y location defines how far along the thrower starts..  in this case, he throws at 180, and starts at 170.. This means his first throw will occur fairly quickly..
									;Last = how often the thrower should throw..
		AddBaddy(790,185,790,140,1,10)	;And a hopping Stickman to act as a visible thrower
									
	Default
		;Occurs if all levels are finished, or if you forgot to put one in!
		SetBuffer BackBuffer()
		DrawImage paper,0,0
		Col 2
		SetFont LargeFont
		Text 400,304,"YU HAF WIND DE GAIM!",1,1
		Flip
		Delay 1500
		End
	
End Select
SetBuffer BackBuffer()

CopyRect 0,0,800,600,0,0,ImageBuffer(Floors),ImageBuffer(FloorCopy)
Return



Function Col(n)
	;Like those stupid 4-color pens you can get, we'll allow Red, Green, Blue and Black..
	Select N
		Case 1
			Color 0,0,0		;Black
		Case 2
			Color 0,0,180 	;Blue
		Case 3
			Color 180,0,0 	;Red
		Case 4
			Color 0,180,0 	;Green
	End Select
End Function



Function AddLine(x1,y1,x2,y2,c)
Color 255,255,255
Line x1,y1,x2,y2
Line x1,y1,x2,y2+1
Line x1,y1+1,x2,y2+1
Line x1,y1+1,x2,y2+2
Line x1,y1+2,x2,y2+2

If room(0,0)=1
PlrX=X1:PlrY=Y1
EndIf
	room(room(0,0),0)=c:room(room(0,0),1)=x1:room(room(0,0),2)=y1
	room(room(0,0)+1,0)=c:room(room(0,0)+1,1)=x2:room(room(0,0)+1,2)=y2
	room(0,0)=room(0,0)+2
End Function


Function AddBaddy(x1,y1,x2,y2,Style,Frames)
Bad.die=New Die
bad\x1=x1:bad\y1=y1:bad\x2=x2:bad\y2=y2
bad\style=style
bad\frames=frames
If style=2 Then bad\frame=y2
bad\FrameDirection=1
End Function

Function AddText(x,y,txt$,cl)
te.xt=New xt
te\x=x
te\y=((y-1)*(33.7))+42
te\txt$=txt$
te\cl=cl
End Function


Function ShowRoom()
	If show(0,0)<room(0,0)
		show(0,0)=show(0,0)+2
		show(show(0,0),0)=room(show(0,0),0)
		show(show(0,0),1)=room(show(0,0),1)
		show(show(0,0),2)=room(show(0,0),2)
		show(show(0,0)+1,0)=room(show(0,0)+1,0)
		show(show(0,0)+1,1)=room(show(0,0)+1,1)
		show(show(0,0)+1,2)=room(show(0,0)+1,2)
	EndIf
	For n=1 To show(0,0) Step 2
		col(show(n,0))
		DrawLine show(n,1),show(n,2),show(n+1,1),show(n+1,2)
	Next
End Function


;These 2 functions are from my old StickMan game from Wed.Workshop #015.
Function Stickman(AtX,AtY,LW=0,Hat=0) ;AtX = Middle, AtY = Foot Level
										;LW = Leg Wiggle, for when moving
										;Hat = Hats.  Why not try adding more hats!  You can even use it to draw silly costumes and stuff!
	SeedRnd MilliSecs()
	;Leg 1
	DrawLine AtX,AtY-14,AtX-10+(Rand(-2,2)*LW),AtY
	SeedRnd MilliSecs()
	;Leg 2
	DrawLine AtX,AtY-14,AtX+10+(Rand(-2,2)*LW),AtY
	;Spine
	DrawLine AtX,AtY-50,AtX,aty-14
	;Arms
	DrawLine AtX-15,aty-40,AtX+15,aty-40
	;Head
	For n=0 To 360 Step 45
	DrawLine AtX+(Sin(n)*10),(aty-60)+(Cos(n)*10),AtX+(Sin(n+45)*10),(aty-60)+(Cos(n+45)*10)
	Next
	
	Select Hat
	
	End Select
	
End Function

Function DrawLine(x1,y1,x2,y2)
If Blitz2D=True 
LockBuffer BackBuffer()
	LDrawn=LDrawn+1 ;Add 1 to the Line count
	SeedRnd (CPUTick/2)+Ldrawn	;Seedrnd based on Line drawn + CPUTick..  Change the / value to speed up/slow down jitteryness

	For n=0 To 90 Step 5 ;Draw some little lines, to give the "Wobbly Line" effect
		xa=x2+(((x1-x2)*n)/100)+Rand(-1,1)
		xb=x2+(((x1-x2)*(n+10))/100)+Rand(-1,1)
		ya=y2+(((y1-y2)*n)/100)+Rand(-1,1)
		yb=y2+(((y1-y2)*(n+10))/100)+Rand(-1,1)
		Line xa,ya,xb,yb
	Next
UnlockBuffer BackBuffer()
EndIf

If Blitz2D=False
	Line x1,y1,x2,y2
EndIf	
End Function
